<?php
include APP_PATH . '/configs/autoload.php';

/**
 * Index controller
 *
 * @author ISC--DAIDP
 * @since 21/09/2015
 */
class Application
{
    public function __construct()
    {
        // read db config
        $this->initDb();
        
        // init controller
        $controller = $this->getParam('c', 'index');
        $controller = str_replace(' ', '', ucwords(str_replace('-', ' ', $controller))) . 'Controller';

        $ctrlPath = APP_PATH . '/Controller/' . $controller . '.php';

        if (! file_exists($ctrlPath)) {
            throw new \Exception('Not found controller directory: '  . $ctrlPath);
        }

        require_once $ctrlPath;

        if (! class_exists($controller)) {
            throw new \Exception('Not found controller class: ' . $controller);
        }

        $oController = new $controller();

        $action = $this->getParam('act', 'index');
        $action = lcfirst(str_replace(' ', '', ucwords(str_replace('-', ' ', $action))) . 'Action');

        if (! method_exists($oController, $action)) {
            throw new \Exception('Not found action ' . $action);
        }

        $oController->init($controller, $action);
        $oController->$action();
        $oController->render();
    }


    public function getParam($name, $default = null)
    {
        return !empty($_GET[$name]) ? $_GET[$name] : $default;
    }
    
    
    protected function initDb()
    {
        $arrConfigs = include APP_PATH . '/configs/database.config.php';
        DbConnection::getInstance()->setConfigs($arrConfigs['db']);       
    }
}