<?php
use TechAPI\Exception;
use TechAPI\Auth\AccessToken;
use TechAPI\Api\SendBrandnameOtp;


/**
 * Demo gửi tin nhắn brandname đến 1 số điện thoại (Gửi trực tiếp)
 * 
 * @author ISC--DAIDP
 * @since 08/04/2016
 */
class BrandnameOtpController extends AbstractController
{
    public function indexAction()
    {
    }
    
    
    public function sendAction()
    {
        if (! $this->isPost()) {
            die('Access is denied.');
        }
        
        try
        {
            // get post data
            $arrData = array(
                'Phone'      => $this->getPost('Phone'),
                'BrandName'  => $this->getPost('BrandName'),
                'Message'    => $this->getPost('Message')
            );
            
            // call api
            $oGrantType = getTechAuthorization();
            $apiSendBrandname = new SendBrandnameOtp($arrData);
            $arrData = $oGrantType->execute($apiSendBrandname);
        
            if (! empty($arrData['error']))
            {
                // clear access token when error
                AccessToken::getInstance()->clear();
                
                throw new Exception($arrData['error_description'], $arrData['error']);
            }
            
            $this->view->RESULT = $arrData;
        }
        catch (\Exception $ex)
        {
            $this->view->ERROR = array(
                'code'    => $ex->getCode(),
                'message' => $ex->getMessage()
            );
        }
    }
}