<?php
use TechAPI\Api\SendMtActive;
use TechAPI\Exception;
use TechAPI\Auth\AccessToken;


/**
 * Demo gửi tin nhắn đến 1 số điện thoại
 * 
 * @author ISC--DAIDP
 * @since 21/09/2015
 */
class IndexController extends AbstractController
{
    public function indexAction()
    {
    }
    
    
    public function sendAction()
    {
        if (! $this->isPost()) {
            die('Access is denied.');
        }
        
        try
        {
            // get post data
            $arrData = array(
                'ServiceNum' => $this->getPost('ServiceNum'),
                'Phone'      => $this->getPost('Phone'),
                'Syntax'     => $this->getPost('Syntax'),
                'Message'    => $this->getPost('Message')
            );
        
            // insert data to database
            $mSendResult = $this->loadModel('SendResultModel');
            $idInsert    = $mSendResult->add($arrData);
            
            
            // call api
            $oGrantType = getTechAuthorization();
            $apiSendMtActive = new SendMtActive($arrData);
            $arrData = $oGrantType->execute($apiSendMtActive);
        
            if (! empty($arrData['error']))
            {
                // clear access token when error
                AccessToken::getInstance()->clear();
                
                throw new Exception($arrData['error_description'], $arrData['error']);
            }
        
            // update status
            $mSendResult->updateSuccess($idInsert, $arrData);
            
            $this->view->RESULT = $arrData;
        }
        catch (\Exception $ex)
        {
            $this->view->ERROR = array(
                'code'    => $ex->getCode(),
                'message' => $ex->getMessage()
            );
        }
    }
}