<?php
use TechAPI\Api\SendMtActive;
use TechAPI\Exception;
use TechAPI\Auth\AccessToken;


/**
 * Demo gửi tin nhắn đến nhiều số điện thoại trong danh sách
 * 
 * @author ISC--DAIDP
 * @since 02/10/2015
 */
class MultiController extends AbstractController
{
    public function indexAction()
    {        
    }
    
    
    public function sendAction()
    {
        if (! $this->isPost()) {
            die('Access is denied.');
        }
        
        $arrNotification = array();
        
        // get post data
        $arrData = array(
            'Telco'      => 'vina',
            'ServiceNum' => $this->getPost('ServiceNum'),
            'Syntax'     => $this->getPost('Syntax'),
            'Message'    => $this->getPost('Message')
        );
    
        // get Phone list
        $mPhoneList = $this->loadModel('PhoneListModel');
        $arrPhones  = $mPhoneList->getList();
        
        /** Init api context **/
        try {
            $oGrantType = getTechAuthorization();
        }
        catch (Exception $ex) {
            die($ex->getMessage());
        }
        
        /** Send to each phone number **/
        foreach ($arrPhones as $item)
        {
            $arrData['Phone'] = $item['Phone'];
            
            // insert data to database
            $mSendResult = $this->loadModel('SendResultModel');
            $idInsert    = $mSendResult->add($arrData);
            
            try
            {
                // call api
                $apiSendMtActive = new SendMtActive($arrData);
                $arrData = $oGrantType->execute($apiSendMtActive);
            
                if (! empty($arrData['error']))
                {
                    // clear access token when error
                    AccessToken::getInstance()->clear();

                    throw new Exception($arrData['error_description'], $arrData['error']);
                }

                // update status
                $mSendResult->updateSuccess($idInsert, $arrData);
                
                $arrNotification[] = sprintf('Kết quả %s - Gửi thành công', $item['Phone']);
            }
            catch (\Exception $ex)
            {
                $arrNotification[] = sprintf('Kết quả %s - Lỗi (%s): %s', $item['Phone'], $ex->getCode(), $ex->getMessage());
            }
        }
        
        
        $this->view->NOTIFICATION = $arrNotification;
    }
}