<?php
use TechAPI\Api\SendMtActive;
use TechAPI\Exception as TechException;
use TechAPI\Auth\AccessToken;


/**
 * Demo gửi tin nhắn đến 1 số điện thoại
 * 
 * @author ISC--DAIDP
 * @since 21/09/2015
 */
class SimpleController extends AbstractController
{
    public function indexAction()
    {        
        // Khởi tạo các tham số của tin nhắn.
        $arrMessage = array(
            'ServiceNum' => 8700,
            'Phone'      => '0943533173',
            'Message'    => 'Lorem ipsum dolor sit amet, consectetur adipiscing elit'
        );
        
        // Khởi tạo đối tượng API với các tham số phía trên.
        $apiSendMtActive = new SendMtActive($arrMessage);
        
        try
        {
            // Lấy đối tượng Authorization để thực thi API
            $oGrantType      = getTechAuthorization();
        
            // Thực thi API
            $arrResponse     = $oGrantType->execute($apiSendMtActive);
        
            // kiểm tra kết quả trả về có lỗi hay không
            if (! empty($arrResponse['error']))
            {
                // Xóa cache access token khi có lỗi xảy ra từ phía server
                AccessToken::getInstance()->clear();
        
                // quăng lỗi ra, và ghi log
                throw new TechException($arrResponse['error_description'], $arrResponse['error']);
            }
        
            echo '<pre>';
            print_r($arrResponse);
            echo '</pre>';
        }
        catch (\Exception $ex)
        {
            echo sprintf('<p>Có lỗi xảy ra:</p>');
            echo sprintf('<p>- Mã lỗi: %s</p>', $ex->getCode());
            echo sprintf('<p>- Mô tả lỗi: %s</p>', $ex->getMessage());
        }
        
        die();
    }
}